#! /usr/bin/python
#***********************************************************
#* Software License Agreement (BSD License)
#*
#*  Copyright (c) 2009, Willow Garage, Inc.
#*  All rights reserved.
#*
#*  Redistribution and use in source and binary forms, with or without
#*  modification, are permitted provided that the following conditions
#*  are met:
#*
#*   * Redistributions of source code must retain the above copyright
#*     notice, this list of conditions and the following disclaimer.
#*   * Redistributions in binary form must reproduce the above
#*     copyright notice, this list of conditions and the following
#*     disclaimer in the documentation and/or other materials provided
#*     with the distribution.
#*   * Neither the name of Willow Garage, Inc. nor the names of its
#*     contributors may be used to endorse or promote products derived
#*     from this software without specific prior written permission.
#*
#*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
#*  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
#*  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
#*  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
#*  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
#*  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
#*  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
#*  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
#*  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
#*  POSSIBILITY OF SUCH DAMAGE.
#* 
#* Author: Eitan Marder-Eppstein
#***********************************************************
PKG = 'icra_navigation_gazebo'
import roslib
roslib.load_manifest(PKG)
import rospy  
import time
import actionlib
import unittest



from move_base_msgs.msg import *
from geometry_msgs.msg import *
from roslib.msg import *

class TestBlindCorner(unittest.TestCase):
  def test_obstacle_slalom(self):
    client = actionlib.SimpleActionClient('move_base_local', MoveBaseAction)
    client.wait_for_server()

    goal = MoveBaseGoal(PoseStamped(Header(frame_id = 'base_link'),
                                  Pose(Point(13.0, 0.0, 0),
                                       Quaternion(0, 0, 0, 1))))
    client.send_goal(goal)
    client.wait_for_result()

    self.assertEquals(client.get_state(), actionlib.GoalStatus.SUCCEEDED, 'Goal did not succeed. Goal status: %d' % client.get_state() )

if __name__ == '__main__':
  import rostest
  rospy.init_node('obstacle_slalom_tester')
  rostest.unitrun(PKG, 'test_obstacle_slalom', TestBlindCorner)
